// Package v2 provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen version v1.8.2 DO NOT EDIT.
package v2

import (
	"bytes"
	"compress/gzip"
	"encoding/base64"
	"fmt"
	"net/http"
	"net/url"
	"path"
	"strings"

	"github.com/deepmap/oapi-codegen/pkg/runtime"
	"github.com/getkin/kin-openapi/openapi3"
	"github.com/labstack/echo/v4"
)

const (
	BearerScopes = "Bearer.Scopes"
)

// Defines values for AzureUploadOptionsHyperVGeneration.
const (
	AzureUploadOptionsHyperVGenerationV1 AzureUploadOptionsHyperVGeneration = "V1"

	AzureUploadOptionsHyperVGenerationV2 AzureUploadOptionsHyperVGeneration = "V2"
)

// Defines values for BlueprintCustomizationsPartitioningMode.
const (
	BlueprintCustomizationsPartitioningModeAutoLvm BlueprintCustomizationsPartitioningMode = "auto-lvm"

	BlueprintCustomizationsPartitioningModeLvm BlueprintCustomizationsPartitioningMode = "lvm"

	BlueprintCustomizationsPartitioningModeRaw BlueprintCustomizationsPartitioningMode = "raw"
)

// Defines values for ComposeStatusValue.
const (
	ComposeStatusValueFailure ComposeStatusValue = "failure"

	ComposeStatusValuePending ComposeStatusValue = "pending"

	ComposeStatusValueSuccess ComposeStatusValue = "success"
)

// Defines values for CustomizationsPartitioningMode.
const (
	CustomizationsPartitioningModeAutoLvm CustomizationsPartitioningMode = "auto-lvm"

	CustomizationsPartitioningModeLvm CustomizationsPartitioningMode = "lvm"

	CustomizationsPartitioningModeRaw CustomizationsPartitioningMode = "raw"
)

// Defines values for ImageSBOMPipelinePurpose.
const (
	ImageSBOMPipelinePurposeBuildroot ImageSBOMPipelinePurpose = "buildroot"

	ImageSBOMPipelinePurposeImage ImageSBOMPipelinePurpose = "image"
)

// Defines values for ImageSBOMSbomType.
const (
	ImageSBOMSbomTypeSpdx ImageSBOMSbomType = "spdx"
)

// Defines values for ImageStatusValue.
const (
	ImageStatusValueBuilding ImageStatusValue = "building"

	ImageStatusValueFailure ImageStatusValue = "failure"

	ImageStatusValuePending ImageStatusValue = "pending"

	ImageStatusValueRegistering ImageStatusValue = "registering"

	ImageStatusValueSuccess ImageStatusValue = "success"

	ImageStatusValueUploading ImageStatusValue = "uploading"
)

// Defines values for ImageTypes.
const (
	ImageTypesAws ImageTypes = "aws"

	ImageTypesAwsHaRhui ImageTypes = "aws-ha-rhui"

	ImageTypesAwsRhui ImageTypes = "aws-rhui"

	ImageTypesAwsSapRhui ImageTypes = "aws-sap-rhui"

	ImageTypesAzure ImageTypes = "azure"

	ImageTypesAzureEap7Rhui ImageTypes = "azure-eap7-rhui"

	ImageTypesAzureRhui ImageTypes = "azure-rhui"

	ImageTypesAzureSapRhui ImageTypes = "azure-sap-rhui"

	ImageTypesEdgeCommit ImageTypes = "edge-commit"

	ImageTypesEdgeContainer ImageTypes = "edge-container"

	ImageTypesEdgeInstaller ImageTypes = "edge-installer"

	ImageTypesGcp ImageTypes = "gcp"

	ImageTypesGcpRhui ImageTypes = "gcp-rhui"

	ImageTypesGuestImage ImageTypes = "guest-image"

	ImageTypesImageInstaller ImageTypes = "image-installer"

	ImageTypesIotBootableContainer ImageTypes = "iot-bootable-container"

	ImageTypesIotCommit ImageTypes = "iot-commit"

	ImageTypesIotContainer ImageTypes = "iot-container"

	ImageTypesIotInstaller ImageTypes = "iot-installer"

	ImageTypesIotRawImage ImageTypes = "iot-raw-image"

	ImageTypesIotSimplifiedInstaller ImageTypes = "iot-simplified-installer"

	ImageTypesLiveInstaller ImageTypes = "live-installer"

	ImageTypesMinimalRaw ImageTypes = "minimal-raw"

	ImageTypesOci ImageTypes = "oci"

	ImageTypesVsphere ImageTypes = "vsphere"

	ImageTypesVsphereOva ImageTypes = "vsphere-ova"

	ImageTypesWsl ImageTypes = "wsl"
)

// Defines values for UploadStatusValue.
const (
	UploadStatusValueFailure UploadStatusValue = "failure"

	UploadStatusValuePending UploadStatusValue = "pending"

	UploadStatusValueRunning UploadStatusValue = "running"

	UploadStatusValueSuccess UploadStatusValue = "success"
)

// Defines values for UploadTypes.
const (
	UploadTypesAws UploadTypes = "aws"

	UploadTypesAwsS3 UploadTypes = "aws.s3"

	UploadTypesAzure UploadTypes = "azure"

	UploadTypesContainer UploadTypes = "container"

	UploadTypesGcp UploadTypes = "gcp"

	UploadTypesLocal UploadTypes = "local"

	UploadTypesOciObjectstorage UploadTypes = "oci.objectstorage"

	UploadTypesPulpOstree UploadTypes = "pulp.ostree"
)

// AWSEC2CloneCompose defines model for AWSEC2CloneCompose.
type AWSEC2CloneCompose struct {
	Region            string    `json:"region"`
	ShareWithAccounts *[]string `json:"share_with_accounts,omitempty"`
}

// AWSEC2UploadOptions defines model for AWSEC2UploadOptions.
type AWSEC2UploadOptions struct {
	Region            string   `json:"region"`
	ShareWithAccounts []string `json:"share_with_accounts"`
	SnapshotName      *string  `json:"snapshot_name,omitempty"`
}

// AWSEC2UploadStatus defines model for AWSEC2UploadStatus.
type AWSEC2UploadStatus struct {
	Ami    string `json:"ami"`
	Region string `json:"region"`
}

// AWSS3UploadOptions defines model for AWSS3UploadOptions.
type AWSS3UploadOptions struct {
	// If set to false (the default value), a long, obfuscated URL
	// is returned. Its expiration might be sooner than for other upload
	// targets.
	//
	// If set to true, a shorter URL is returned and
	// its expiration is the same as for the other upload targets.
	Public *bool  `json:"public,omitempty"`
	Region string `json:"region"`
}

// AWSS3UploadStatus defines model for AWSS3UploadStatus.
type AWSS3UploadStatus struct {
	Url string `json:"url"`
}

// AzureUploadOptions defines model for AzureUploadOptions.
type AzureUploadOptions struct {
	// Choose the VM Image HyperV generation, different features on Azure are available
	// depending on the HyperV generation.
	HyperVGeneration *AzureUploadOptionsHyperVGeneration `json:"hyper_v_generation,omitempty"`

	// Name of the uploaded image. It must be unique in the given resource group.
	// If name is omitted from the request, a random one based on a UUID is
	// generated.
	ImageName *string `json:"image_name,omitempty"`

	// Location of the provided resource_group, where the image should be uploaded and registered.
	// How to list all locations:
	// https://docs.microsoft.com/en-us/cli/azure/account?view=azure-cli-latest#az_account_list_locations'
	// If the location is not specified, it is deducted from the provided resource_group.
	Location *string `json:"location,omitempty"`

	// Name of the resource group where the image should be uploaded.
	ResourceGroup string `json:"resource_group"`

	// ID of subscription where the image should be uploaded.
	SubscriptionId string `json:"subscription_id"`

	// ID of the tenant where the image should be uploaded.
	// How to find it in the Azure Portal:
	// https://docs.microsoft.com/en-us/azure/active-directory/fundamentals/active-directory-how-to-find-tenant
	TenantId string `json:"tenant_id"`
}

// Choose the VM Image HyperV generation, different features on Azure are available
// depending on the HyperV generation.
type AzureUploadOptionsHyperVGeneration string

// AzureUploadStatus defines model for AzureUploadStatus.
type AzureUploadStatus struct {
	ImageName string `json:"image_name"`
}

// Blueprint defines model for Blueprint.
type Blueprint struct {
	// Container images to embed into the final artfact
	Containers     *[]Container             `json:"containers,omitempty"`
	Customizations *BlueprintCustomizations `json:"customizations,omitempty"`
	Description    *string                  `json:"description,omitempty"`

	// The distribution to use for the compose. If left empty the host
	// distro will be used.
	Distro *string `json:"distro,omitempty"`

	// Package groups to be installed
	Groups *[]PackageGroup `json:"groups,omitempty"`

	// An alias for packages, retained for backwards compatability
	Modules *[]Package `json:"modules,omitempty"`
	Name    string     `json:"name"`

	// Packages to be installed
	Packages *[]Package `json:"packages,omitempty"`

	// A semver version number
	Version *string `json:"version,omitempty"`
}

// BlueprintCustomizations defines model for BlueprintCustomizations.
type BlueprintCustomizations struct {
	// Directories to create in the final artifact
	Directories *[]Directory `json:"directories,omitempty"`

	// FIDO device onboard configuration
	Fdo *FDO `json:"fdo,omitempty"`

	// Files to create in the final artifact
	Files *[]BlueprintFile `json:"files,omitempty"`

	// List of filesystem mountpoints to create
	Filesystem *[]BlueprintFilesystem `json:"filesystem,omitempty"`

	// Enable FIPS mode
	Fips *bool `json:"fips,omitempty"`

	// Firewalld configuration
	Firewall *BlueprintFirewall `json:"firewall,omitempty"`

	// List of groups to create
	Group *[]Group `json:"group,omitempty"`

	// Configures the hostname
	Hostname *string `json:"hostname,omitempty"`

	// Ignition configuration
	Ignition *Ignition `json:"ignition,omitempty"`

	// Name of the installation device, currently only useful for the edge-simplified-installer type
	InstallationDevice *string    `json:"installation_device,omitempty"`
	Installer          *Installer `json:"installer,omitempty"`
	Kernel             *Kernel    `json:"kernel,omitempty"`

	// Locale configuration
	Locale   *Locale            `json:"locale,omitempty"`
	Openscap *BlueprintOpenSCAP `json:"openscap,omitempty"`

	// Select how the disk image will be partitioned. 'auto-lvm' will use raw unless
	// there are one or more mountpoints in which case it will use LVM. 'lvm' always
	// uses LVM, even when there are no extra mountpoints. 'raw' uses raw partitions
	// even when there are one or more mountpoints.
	PartitioningMode *BlueprintCustomizationsPartitioningMode `json:"partitioning_mode,omitempty"`

	// Repositories to write to /etc/yum.repos.d/ in the final image. Note
	// that these are not used at build time.
	Repositories *[]BlueprintRepository `json:"repositories,omitempty"`
	Rhsm         *RHSMCustomization     `json:"rhsm,omitempty"`
	Rpm          *RPMCustomization      `json:"rpm,omitempty"`
	Services     *Services              `json:"services,omitempty"`

	// List of ssh keys
	Sshkey *[]SSHKey `json:"sshkey,omitempty"`

	// Timezone configuration
	Timezone *Timezone `json:"timezone,omitempty"`

	// List of users to create
	User *[]BlueprintUser `json:"user,omitempty"`
}

// Select how the disk image will be partitioned. 'auto-lvm' will use raw unless
// there are one or more mountpoints in which case it will use LVM. 'lvm' always
// uses LVM, even when there are no extra mountpoints. 'raw' uses raw partitions
// even when there are one or more mountpoints.
type BlueprintCustomizationsPartitioningMode string

// A custom file to create in the final artifact.
type BlueprintFile struct {
	// Contents of the file as plain text
	Data *string `json:"data,omitempty"`

	// Group of the file as a gid or a group name
	Group *interface{} `json:"group,omitempty"`

	// Permissions string for the file in octal format
	Mode *string `json:"mode,omitempty"`

	// Path to the file
	Path string `json:"path"`

	// Owner of the file as a uid or a user name
	User *interface{} `json:"user,omitempty"`
}

// BlueprintFilesystem defines model for BlueprintFilesystem.
type BlueprintFilesystem struct {
	// size of the filesystem in bytes
	Minsize    uint64 `json:"minsize"`
	Mountpoint string `json:"mountpoint"`
}

// Firewalld configuration
type BlueprintFirewall struct {
	// List of ports (or port ranges) and protocols to open
	Ports *[]string `json:"ports,omitempty"`

	// Firewalld services to enable or disable
	Services *FirewallServices `json:"services,omitempty"`
	Zones    *[]FirewallZones  `json:"zones,omitempty"`
}

// BlueprintOpenSCAP defines model for BlueprintOpenSCAP.
type BlueprintOpenSCAP struct {
	Datastream    *string                `json:"datastream,omitempty"`
	JsonTailoring *OpenSCAPJSONTailoring `json:"json_tailoring,omitempty"`

	// Puts a specified policy ID in the RHSM facts, so that any instances registered to
	// insights will be automatically connected to the compliance policy in the console.
	PolicyId  *string            `json:"policy_id,omitempty"`
	ProfileId string             `json:"profile_id"`
	Tailoring *OpenSCAPTailoring `json:"tailoring,omitempty"`
}

// BlueprintRepository defines model for BlueprintRepository.
type BlueprintRepository struct {
	Baseurls   *[]string `json:"baseurls,omitempty"`
	Enabled    *bool     `json:"enabled,omitempty"`
	Filename   *string   `json:"filename,omitempty"`
	Gpgcheck   *bool     `json:"gpgcheck,omitempty"`
	Gpgkeys    *[]string `json:"gpgkeys,omitempty"`
	Id         string    `json:"id"`
	Metalink   *string   `json:"metalink,omitempty"`
	Mirrorlist *string   `json:"mirrorlist,omitempty"`

	// Disables modularity filtering for this repository.
	ModuleHotfixes *bool   `json:"module_hotfixes,omitempty"`
	Name           *string `json:"name,omitempty"`
	Priority       *int    `json:"priority,omitempty"`
	RepoGpgcheck   *bool   `json:"repo_gpgcheck,omitempty"`
	Sslverify      *bool   `json:"sslverify,omitempty"`
}

// BlueprintUser defines model for BlueprintUser.
type BlueprintUser struct {
	Description *string `json:"description,omitempty"`

	// Group id to use instead of the default
	Gid *int `json:"gid,omitempty"`

	// A list of additional groups to add the user to
	Groups *[]string `json:"groups,omitempty"`

	// The user's home directory
	Home *string `json:"home,omitempty"`

	// ssh public key
	Key  *string `json:"key,omitempty"`
	Name string  `json:"name"`

	// If the password starts with $6$, $5$, or $2b$ it will be stored as
	// an encrypted password. Otherwise it will be treated as a plain text
	// password.
	Password *string `json:"password,omitempty"`

	// Login shell to use
	Shell *string `json:"shell,omitempty"`

	// User id to use instead of the default
	Uid *int `json:"uid,omitempty"`
}

// CloneComposeBody defines model for CloneComposeBody.
type CloneComposeBody interface{}

// CloneComposeResponse defines model for CloneComposeResponse.
type CloneComposeResponse struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Id string `json:"id"`
}

// CloneStatus defines model for CloneStatus.
type CloneStatus struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded struct due to allOf(#/components/schemas/UploadStatus)
	UploadStatus `yaml:",inline"`
}

// ComposeId defines model for ComposeId.
type ComposeId struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Id string `json:"id"`
}

// ComposeLogs defines model for ComposeLogs.
type ComposeLogs struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	ImageBuilds []interface{} `json:"image_builds"`
	Koji        *KojiLogs     `json:"koji,omitempty"`
}

// ComposeManifests defines model for ComposeManifests.
type ComposeManifests struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Manifests []interface{} `json:"manifests"`
}

// ComposeMetadata defines model for ComposeMetadata.
type ComposeMetadata struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	// ID (hash) of the built commit
	OstreeCommit *string `json:"ostree_commit,omitempty"`

	// Package list including NEVRA
	Packages *[]PackageMetadata `json:"packages,omitempty"`
	Request  *ComposeRequest    `json:"request,omitempty"`
}

// ComposeRequest defines model for ComposeRequest.
type ComposeRequest struct {
	Blueprint      *Blueprint      `json:"blueprint,omitempty"`
	Customizations *Customizations `json:"customizations,omitempty"`
	Distribution   string          `json:"distribution"`
	ImageRequest   *ImageRequest   `json:"image_request,omitempty"`
	ImageRequests  *[]ImageRequest `json:"image_requests,omitempty"`
	Koji           *Koji           `json:"koji,omitempty"`
}

// ComposeSBOMs defines model for ComposeSBOMs.
type ComposeSBOMs struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	// The SBOM documents for each image built in the compose.
	Items [][]ImageSBOM `json:"items"`
}

// ComposeStatus defines model for ComposeStatus.
type ComposeStatus struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	ImageStatus   ImageStatus        `json:"image_status"`
	ImageStatuses *[]ImageStatus     `json:"image_statuses,omitempty"`
	KojiStatus    *KojiStatus        `json:"koji_status,omitempty"`
	Status        ComposeStatusValue `json:"status"`
}

// ComposeStatusError defines model for ComposeStatusError.
type ComposeStatusError struct {
	Details *interface{} `json:"details,omitempty"`
	Id      int          `json:"id"`
	Reason  string       `json:"reason"`
}

// ComposeStatusValue defines model for ComposeStatusValue.
type ComposeStatusValue string

// Container defines model for Container.
type Container struct {
	// Name to use for the container from the image
	Name *string `json:"name,omitempty"`

	// Reference to the container to embed
	Source string `json:"source"`

	// Control TLS verifification
	TlsVerify *bool `json:"tls_verify,omitempty"`
}

// ContainerUploadOptions defines model for ContainerUploadOptions.
type ContainerUploadOptions struct {
	// Name for the created container image
	Name *string `json:"name,omitempty"`

	// Tag for the created container image
	Tag *string `json:"tag,omitempty"`
}

// ContainerUploadStatus defines model for ContainerUploadStatus.
type ContainerUploadStatus struct {
	// Digest of the manifest of the uploaded container on the registry
	Digest string `json:"digest"`

	// FQDN of the uploaded image
	Url string `json:"url"`
}

// CustomRepository defines model for CustomRepository.
type CustomRepository struct {
	Baseurl        *[]string `json:"baseurl,omitempty"`
	CheckGpg       *bool     `json:"check_gpg,omitempty"`
	CheckRepoGpg   *bool     `json:"check_repo_gpg,omitempty"`
	Enabled        *bool     `json:"enabled,omitempty"`
	Filename       *string   `json:"filename,omitempty"`
	Gpgkey         *[]string `json:"gpgkey,omitempty"`
	Id             string    `json:"id"`
	Metalink       *string   `json:"metalink,omitempty"`
	Mirrorlist     *string   `json:"mirrorlist,omitempty"`
	ModuleHotfixes *bool     `json:"module_hotfixes,omitempty"`
	Name           *string   `json:"name,omitempty"`
	Priority       *int      `json:"priority,omitempty"`
	SslVerify      *bool     `json:"ssl_verify,omitempty"`
}

// Customizations defines model for Customizations.
type Customizations struct {
	Containers *[]Container `json:"containers,omitempty"`

	// Extra repositories for packages specified in customizations. These
	// repositories will be used to depsolve and retrieve packages. Additionally,
	// these packages will be saved and imported to the `/etc/yum.repos.d/` directory
	// on the image
	CustomRepositories *[]CustomRepository `json:"custom_repositories,omitempty"`
	Directories        *[]Directory        `json:"directories,omitempty"`

	// FIDO device onboard configuration
	Fdo        *FDO          `json:"fdo,omitempty"`
	Files      *[]File       `json:"files,omitempty"`
	Filesystem *[]Filesystem `json:"filesystem,omitempty"`

	// System FIPS mode setup
	Fips *FIPS `json:"fips,omitempty"`

	// Firewalld configuration
	Firewall *FirewallCustomization `json:"firewall,omitempty"`

	// List of groups to create
	Groups *[]Group `json:"groups,omitempty"`

	// Configures the hostname
	Hostname *string `json:"hostname,omitempty"`

	// Ignition configuration
	Ignition *Ignition `json:"ignition,omitempty"`

	// Name of the installation device, currently only useful for the edge-simplified-installer type
	InstallationDevice *string    `json:"installation_device,omitempty"`
	Installer          *Installer `json:"installer,omitempty"`
	Kernel             *Kernel    `json:"kernel,omitempty"`

	// Locale configuration
	Locale   *Locale   `json:"locale,omitempty"`
	Openscap *OpenSCAP `json:"openscap,omitempty"`
	Packages *[]string `json:"packages,omitempty"`

	// Select how the disk image will be partitioned. 'auto-lvm' will use raw unless
	// there are one or more mountpoints in which case it will use LVM. 'lvm' always
	// uses LVM, even when there are no extra mountpoints. 'raw' uses raw partitions
	// even when there are one or more mountpoints.
	PartitioningMode *CustomizationsPartitioningMode `json:"partitioning_mode,omitempty"`

	// Extra repositories for packages specified in customizations. These
	// repositories will only be used to depsolve and retrieve packages
	// for the OS itself (they will not be available for the build root or
	// any other part of the build process). The package_sets field for these
	// repositories is ignored.
	PayloadRepositories *[]Repository      `json:"payload_repositories,omitempty"`
	Rhsm                *RHSMCustomization `json:"rhsm,omitempty"`
	Rpm                 *RPMCustomization  `json:"rpm,omitempty"`
	Services            *Services          `json:"services,omitempty"`
	Subscription        *Subscription      `json:"subscription,omitempty"`

	// Timezone configuration
	Timezone *Timezone `json:"timezone,omitempty"`
	Users    *[]User   `json:"users,omitempty"`
}

// Select how the disk image will be partitioned. 'auto-lvm' will use raw unless
// there are one or more mountpoints in which case it will use LVM. 'lvm' always
// uses LVM, even when there are no extra mountpoints. 'raw' uses raw partitions
// even when there are one or more mountpoints.
type CustomizationsPartitioningMode string

// DNFPluginConfig defines model for DNFPluginConfig.
type DNFPluginConfig struct {
	Enabled *bool `json:"enabled,omitempty"`
}

// A custom directory to create in the final artifact.
type Directory struct {
	// Ensure that the parent directories exist
	EnsureParents *bool `json:"ensure_parents,omitempty"`

	// Group of the directory as a group name or a gid
	Group *interface{} `json:"group,omitempty"`

	// Permissions string for the directory in octal format
	Mode *string `json:"mode,omitempty"`

	// Path to the directory
	Path string `json:"path"`

	// Owner of the directory as a user name or a uid
	User *interface{} `json:"user,omitempty"`
}

// Error defines model for Error.
type Error struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Code        string       `json:"code"`
	Details     *interface{} `json:"details,omitempty"`
	OperationId string       `json:"operation_id"`
	Reason      string       `json:"reason"`
}

// ErrorList defines model for ErrorList.
type ErrorList struct {
	// Embedded struct due to allOf(#/components/schemas/List)
	List `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Items []Error `json:"items"`
}

// FIDO device onboard configuration
type FDO struct {
	DiMfgStringTypeMacIface *string `json:"di_mfg_string_type_mac_iface,omitempty"`
	DiunPubKeyHash          *string `json:"diun_pub_key_hash,omitempty"`
	DiunPubKeyInsecure      *string `json:"diun_pub_key_insecure,omitempty"`
	DiunPubKeyRootCerts     *string `json:"diun_pub_key_root_certs,omitempty"`
	ManufacturingServerUrl  *string `json:"manufacturing_server_url,omitempty"`
}

// System FIPS mode setup
type FIPS struct {
	// Enables the system FIPS mode
	Enabled *bool `json:"enabled,omitempty"`
}

// A custom file to create in the final artifact.
type File struct {
	// Contents of the file as plain text
	Data *string `json:"data,omitempty"`

	// Ensure that the parent directories exist
	EnsureParents *bool `json:"ensure_parents,omitempty"`

	// Group of the file as a gid or a group name
	Group *interface{} `json:"group,omitempty"`

	// Permissions string for the file in octal format
	Mode *string `json:"mode,omitempty"`

	// Path to the file
	Path string `json:"path"`

	// Owner of the file as a uid or a user name
	User *interface{} `json:"user,omitempty"`
}

// Filesystem defines model for Filesystem.
type Filesystem struct {
	// size of the filesystem in bytes
	MinSize    uint64 `json:"min_size"`
	Mountpoint string `json:"mountpoint"`
}

// Firewalld configuration
type FirewallCustomization struct {
	// List of ports (or port ranges) and protocols to open
	Ports *[]string `json:"ports,omitempty"`

	// Firewalld services to enable or disable
	Services *FirewallServices `json:"services,omitempty"`
}

// Firewalld services to enable or disable
type FirewallServices struct {
	// List of services to disable
	Disabled *[]string `json:"disabled,omitempty"`

	// List of services to enable
	Enabled *[]string `json:"enabled,omitempty"`
}

// Bind a list of network sources to a zone to restrict traffic from
// those sources based on the settings of the zone.
type FirewallZones struct {
	// name of the zone, if left empty the sources will apply to
	// the default zone.
	Name *string `json:"name,omitempty"`

	// List of sources for the zone
	Sources *[]string `json:"sources,omitempty"`
}

// GCPUploadOptions defines model for GCPUploadOptions.
type GCPUploadOptions struct {
	// Name of an existing STANDARD Storage class Bucket.
	Bucket *string `json:"bucket,omitempty"`

	// The name to use for the imported and shared Compute Engine image.
	// The image name must be unique within the GCP project, which is used
	// for the OS image upload and import. If not specified a random
	// 'composer-api-<uuid>' string is used as the image name.
	ImageName *string `json:"image_name,omitempty"`

	// The GCP region where the OS image will be imported to and shared from.
	// The value must be a valid GCP location. See https://cloud.google.com/storage/docs/locations.
	// If not specified, the multi-region location closest to the source
	// (source Storage Bucket location) is chosen automatically.
	Region string `json:"region"`

	// List of valid Google accounts to share the imported Compute Engine image with.
	// Each string must contain a specifier of the account type. Valid formats are:
	//   - 'user:{emailid}': An email address that represents a specific
	//     Google account. For example, 'alice@example.com'.
	//   - 'serviceAccount:{emailid}': An email address that represents a
	//     service account. For example, 'my-other-app@appspot.gserviceaccount.com'.
	//   - 'group:{emailid}': An email address that represents a Google group.
	//     For example, 'admins@example.com'.
	//   - 'domain:{domain}': The G Suite domain (primary) that represents all
	//     the users of that domain. For example, 'google.com' or 'example.com'.
	// If not specified, the imported Compute Engine image is not shared with any
	// account.
	ShareWithAccounts *[]string `json:"share_with_accounts,omitempty"`
}

// GCPUploadStatus defines model for GCPUploadStatus.
type GCPUploadStatus struct {
	ImageName string `json:"image_name"`
	ProjectId string `json:"project_id"`
}

// Group defines model for Group.
type Group struct {
	// Group id of the group to create (optional)
	Gid *int `json:"gid,omitempty"`

	// Name of the group to create
	Name string `json:"name"`
}

// Ignition configuration
type Ignition struct {
	Embedded  *IgnitionEmbedded  `json:"embedded,omitempty"`
	Firstboot *IgnitionFirstboot `json:"firstboot,omitempty"`
}

// IgnitionEmbedded defines model for IgnitionEmbedded.
type IgnitionEmbedded struct {
	Config string `json:"config"`
}

// IgnitionFirstboot defines model for IgnitionFirstboot.
type IgnitionFirstboot struct {
	// Provisioning URL
	Url string `json:"url"`
}

// ImageRequest defines model for ImageRequest.
type ImageRequest struct {
	Architecture string       `json:"architecture"`
	ImageType    ImageTypes   `json:"image_type"`
	Ostree       *OSTree      `json:"ostree,omitempty"`
	Repositories []Repository `json:"repositories"`

	// Size of image, in bytes. When set to 0 the image size is a minimum
	// defined by the image type.
	Size *uint64 `json:"size,omitempty"`

	// Options for a given upload destination.
	// This should really be oneOf but AWSS3UploadOptions is a subset of
	// AWSEC2UploadOptions. This means that all AWSEC2UploadOptions objects
	// are also valid AWSS3UploadOptionas objects which violates the oneOf
	// rules. Therefore, we have to use anyOf here but be aware that it isn't
	// possible to mix and match more schemas together.
	UploadOptions *UploadOptions `json:"upload_options,omitempty"`

	// The type and options for multiple upload targets. Each item defines
	// a separate upload destination with its own options. Multiple
	// different targets as well as multiple targets of the same kind are
	// supported.
	UploadTargets *[]UploadTarget `json:"upload_targets,omitempty"`
}

// ImageSBOM defines model for ImageSBOM.
type ImageSBOM struct {
	// The name of the osbuild pipeline which has the packages described
	// in the SBOM installed.
	PipelineName string `json:"pipeline_name"`

	// The purpose of the pipeline. The `buildroot` pipeline was used for
	// the build environment dueing the image build. The `image` pipeline
	// represents the actual content of the image. Due to the nature of
	// some image types, there may be multiple pipelines of the same
	// purpose.
	PipelinePurpose ImageSBOMPipelinePurpose `json:"pipeline_purpose"`

	// The SBOM document in the 'sbom_type' format.
	Sbom interface{} `json:"sbom"`

	// The type of the SBOM document. Currently only SPDX is supported.
	SbomType ImageSBOMSbomType `json:"sbom_type"`
}

// The purpose of the pipeline. The `buildroot` pipeline was used for
// the build environment dueing the image build. The `image` pipeline
// represents the actual content of the image. Due to the nature of
// some image types, there may be multiple pipelines of the same
// purpose.
type ImageSBOMPipelinePurpose string

// The type of the SBOM document. Currently only SPDX is supported.
type ImageSBOMSbomType string

// ImageStatus defines model for ImageStatus.
type ImageStatus struct {
	Error          *ComposeStatusError `json:"error,omitempty"`
	Status         ImageStatusValue    `json:"status"`
	UploadStatus   *UploadStatus       `json:"upload_status,omitempty"`
	UploadStatuses *[]UploadStatus     `json:"upload_statuses,omitempty"`
}

// ImageStatusValue defines model for ImageStatusValue.
type ImageStatusValue string

// ImageTypes defines model for ImageTypes.
type ImageTypes string

// ImportKeys defines model for ImportKeys.
type ImportKeys struct {
	Files *[]string `json:"files,omitempty"`
}

// Installer defines model for Installer.
type Installer struct {
	SudoNopasswd *[]string `json:"sudo-nopasswd,omitempty"`
	Unattended   *bool     `json:"unattended,omitempty"`
}

// Kernel defines model for Kernel.
type Kernel struct {
	// Appends arguments to the bootloader kernel command line
	Append *string `json:"append,omitempty"`

	// Name of the kernel to use
	Name *string `json:"name,omitempty"`
}

// Koji defines model for Koji.
type Koji struct {
	Name    string `json:"name"`
	Release string `json:"release"`
	Server  string `json:"server"`
	TaskId  int    `json:"task_id"`
	Version string `json:"version"`
}

// KojiLogs defines model for KojiLogs.
type KojiLogs struct {
	Import interface{} `json:"import"`
	Init   interface{} `json:"init"`
}

// KojiStatus defines model for KojiStatus.
type KojiStatus struct {
	BuildId *int `json:"build_id,omitempty"`
}

// List defines model for List.
type List struct {
	Kind  string `json:"kind"`
	Page  int    `json:"page"`
	Size  int    `json:"size"`
	Total int    `json:"total"`
}

// LocalUploadOptions defines model for LocalUploadOptions.
type LocalUploadOptions struct {
	// This is used in combination with the OSBUILD_LOCALSAVE environmental
	// variable on the server to enable saving the compose locally. This
	// is for development use only, and is not available to users.
	LocalSave bool `json:"local_save"`
}

// Locale configuration
type Locale struct {
	// Sets the keyboard layout
	Keyboard *string `json:"keyboard,omitempty"`

	// List of locales to be installed, the first one becomes primary, subsequent ones are secondary
	Languages *[]string `json:"languages,omitempty"`
}

// OCIUploadOptions defines model for OCIUploadOptions.
type OCIUploadOptions map[string]interface{}

// OCIUploadStatus defines model for OCIUploadStatus.
type OCIUploadStatus struct {
	Url string `json:"url"`
}

// OSTree defines model for OSTree.
type OSTree struct {
	// A URL which, if set, is used for fetching content. Implies that `url` is set as well,
	// which will be used for metadata only.
	Contenturl *string `json:"contenturl,omitempty"`

	// Can be either a commit (example: 02604b2da6e954bd34b8b82a835e5a77d2b60ffa), or a branch-like reference (example: rhel/8/x86_64/edge)
	Parent *string `json:"parent,omitempty"`
	Ref    *string `json:"ref,omitempty"`

	// Determines whether a valid subscription manager (candlepin) identity is required to
	// access this repository. Consumer certificates will be used as client certificates when
	// fetching metadata and content.
	Rhsm *bool   `json:"rhsm,omitempty"`
	Url  *string `json:"url,omitempty"`
}

// ObjectReference defines model for ObjectReference.
type ObjectReference struct {
	Href string `json:"href"`
	Id   string `json:"id"`
	Kind string `json:"kind"`
}

// OpenSCAP defines model for OpenSCAP.
type OpenSCAP struct {
	JsonTailoring *OpenSCAPJSONTailoring `json:"json_tailoring,omitempty"`

	// Puts a specified policy ID in the RHSM facts, so that any instances registered to
	// insights will be automatically connected to the compliance policy in the console.
	PolicyId  *string            `json:"policy_id,omitempty"`
	ProfileId string             `json:"profile_id"`
	Tailoring *OpenSCAPTailoring `json:"tailoring,omitempty"`
}

// OpenSCAPJSONTailoring defines model for OpenSCAPJSONTailoring.
type OpenSCAPJSONTailoring struct {
	Filepath  string `json:"filepath"`
	ProfileId string `json:"profile_id"`
}

// OpenSCAPTailoring defines model for OpenSCAPTailoring.
type OpenSCAPTailoring struct {
	Selected   *[]string `json:"selected,omitempty"`
	Unselected *[]string `json:"unselected,omitempty"`
}

// Package defines model for Package.
type Package struct {
	// Name of the package to install. File globbing is supported,
	// eg. 'openssh-*'
	Name string `json:"name"`

	// Optional version of the package to install. If left blank the
	// latest available version will be used. Wildcards are supported
	// eg. '4.11.*'
	Version *string `json:"version,omitempty"`
}

// PackageGroup defines model for PackageGroup.
type PackageGroup struct {
	// Package group name
	Name string `json:"name"`
}

// PackageMetadata defines model for PackageMetadata.
type PackageMetadata struct {
	Arch      string  `json:"arch"`
	Epoch     *string `json:"epoch,omitempty"`
	Name      string  `json:"name"`
	Release   string  `json:"release"`
	Sigmd5    string  `json:"sigmd5"`
	Signature *string `json:"signature,omitempty"`
	Type      string  `json:"type"`
	Version   string  `json:"version"`
}

// PulpOSTreeUploadOptions defines model for PulpOSTreeUploadOptions.
type PulpOSTreeUploadOptions struct {
	// Basepath for distributing the repository
	Basepath string `json:"basepath"`

	// Repository to import the ostree commit to
	Repository    *string `json:"repository,omitempty"`
	ServerAddress *string `json:"server_address,omitempty"`
}

// PulpOSTreeUploadStatus defines model for PulpOSTreeUploadStatus.
type PulpOSTreeUploadStatus struct {
	RepoUrl string `json:"repo_url"`
}

// RHSMConfig defines model for RHSMConfig.
type RHSMConfig struct {
	DnfPlugins          *SubManDNFPluginsConfig `json:"dnf_plugins,omitempty"`
	SubscriptionManager *SubManConfig           `json:"subscription_manager,omitempty"`
}

// RHSMCustomization defines model for RHSMCustomization.
type RHSMCustomization struct {
	Config *RHSMConfig `json:"config,omitempty"`
}

// RPMCustomization defines model for RPMCustomization.
type RPMCustomization struct {
	ImportKeys *ImportKeys `json:"import_keys,omitempty"`
}

// Repository configuration.
// At least one of the 'baseurl', 'mirrorlist', 'metalink' properties must
// be specified. If more of them are specified, the order of precedence is
// the same as listed above.
type Repository struct {
	Baseurl  *string `json:"baseurl,omitempty"`
	CheckGpg *bool   `json:"check_gpg,omitempty"`

	// Enables gpg verification of the repository metadata
	CheckRepoGpg *bool `json:"check_repo_gpg,omitempty"`

	// GPG key used to sign packages in this repository.
	Gpgkey     *string `json:"gpgkey,omitempty"`
	IgnoreSsl  *bool   `json:"ignore_ssl,omitempty"`
	Metalink   *string `json:"metalink,omitempty"`
	Mirrorlist *string `json:"mirrorlist,omitempty"`

	// Disables modularity filtering for this repository.
	ModuleHotfixes *bool `json:"module_hotfixes,omitempty"`

	// Naming package sets for a repository assigns it to a specific part
	// (pipeline) of the build process.
	PackageSets *[]string `json:"package_sets,omitempty"`

	// Determines whether a valid subscription is required to access this repository.
	Rhsm *bool `json:"rhsm,omitempty"`
}

// SSHKey defines model for SSHKey.
type SSHKey struct {
	// Adds the key to the user's authorized_keys file
	Key string `json:"key"`

	// User to configure the ssh key for
	User string `json:"user"`
}

// Services defines model for Services.
type Services struct {
	// List of services to disable by default
	Disabled *[]string `json:"disabled,omitempty"`

	// List of services to enable by default
	Enabled *[]string `json:"enabled,omitempty"`

	// List of services to mask by default
	Masked *[]string `json:"masked,omitempty"`
}

// SubManConfig defines model for SubManConfig.
type SubManConfig struct {
	Rhsm      *SubManRHSMConfig      `json:"rhsm,omitempty"`
	Rhsmcertd *SubManRHSMCertdConfig `json:"rhsmcertd,omitempty"`
}

// SubManDNFPluginsConfig defines model for SubManDNFPluginsConfig.
type SubManDNFPluginsConfig struct {
	ProductId           *DNFPluginConfig `json:"product_id,omitempty"`
	SubscriptionManager *DNFPluginConfig `json:"subscription_manager,omitempty"`
}

// SubManRHSMCertdConfig defines model for SubManRHSMCertdConfig.
type SubManRHSMCertdConfig struct {
	AutoRegistration *bool `json:"auto_registration,omitempty"`
}

// SubManRHSMConfig defines model for SubManRHSMConfig.
type SubManRHSMConfig struct {
	ManageRepos *bool `json:"manage_repos,omitempty"`
}

// Subscription defines model for Subscription.
type Subscription struct {
	ActivationKey string `json:"activation_key"`
	BaseUrl       string `json:"base_url"`
	Insights      bool   `json:"insights"`
	Organization  string `json:"organization"`

	// Optional flag to use rhc to register the system, which also always enables Insights.
	Rhc       *bool  `json:"rhc,omitempty"`
	ServerUrl string `json:"server_url"`
}

// Timezone configuration
type Timezone struct {
	// List of ntp servers
	Ntpservers *[]string `json:"ntpservers,omitempty"`

	// Name of the timezone, defaults to UTC
	Timezone *string `json:"timezone,omitempty"`
}

// Options for a given upload destination.
// This should really be oneOf but AWSS3UploadOptions is a subset of
// AWSEC2UploadOptions. This means that all AWSEC2UploadOptions objects
// are also valid AWSS3UploadOptionas objects which violates the oneOf
// rules. Therefore, we have to use anyOf here but be aware that it isn't
// possible to mix and match more schemas together.
type UploadOptions interface{}

// UploadStatus defines model for UploadStatus.
type UploadStatus struct {
	Options interface{}       `json:"options"`
	Status  UploadStatusValue `json:"status"`
	Type    UploadTypes       `json:"type"`
}

// UploadStatusValue defines model for UploadStatusValue.
type UploadStatusValue string

// UploadTarget defines model for UploadTarget.
type UploadTarget struct {
	Type UploadTypes `json:"type"`

	// Options for a given upload destination.
	// This should really be oneOf but AWSS3UploadOptions is a subset of
	// AWSEC2UploadOptions. This means that all AWSEC2UploadOptions objects
	// are also valid AWSS3UploadOptionas objects which violates the oneOf
	// rules. Therefore, we have to use anyOf here but be aware that it isn't
	// possible to mix and match more schemas together.
	UploadOptions UploadOptions `json:"upload_options"`
}

// UploadTypes defines model for UploadTypes.
type UploadTypes string

// User defines model for User.
type User struct {
	Groups *[]string `json:"groups,omitempty"`
	Key    *string   `json:"key,omitempty"`
	Name   string    `json:"name"`

	// If the password starts with $6$, $5$, or $2b$ it will be stored as
	// an encrypted password. Otherwise it will be treated as a plain text
	// password.
	Password *string `json:"password,omitempty"`
}

// Page defines model for page.
type Page string

// Size defines model for size.
type Size string

// PostComposeJSONBody defines parameters for PostCompose.
type PostComposeJSONBody ComposeRequest

// PostCloneComposeJSONBody defines parameters for PostCloneCompose.
type PostCloneComposeJSONBody CloneComposeBody

// GetErrorListParams defines parameters for GetErrorList.
type GetErrorListParams struct {
	// Page index
	Page *Page `json:"page,omitempty"`

	// Number of items in each page
	Size *Size `json:"size,omitempty"`
}

// PostComposeJSONRequestBody defines body for PostCompose for application/json ContentType.
type PostComposeJSONRequestBody PostComposeJSONBody

// PostCloneComposeJSONRequestBody defines body for PostCloneCompose for application/json ContentType.
type PostCloneComposeJSONRequestBody PostCloneComposeJSONBody

// ServerInterface represents all server handlers.
type ServerInterface interface {
	// The status of a cloned compose
	// (GET /clones/{id})
	GetCloneStatus(ctx echo.Context, id string) error
	// Create compose
	// (POST /compose)
	PostCompose(ctx echo.Context) error
	// The status of a compose
	// (GET /composes/{id})
	GetComposeStatus(ctx echo.Context, id string) error
	// Clone an existing compose
	// (POST /composes/{id}/clone)
	PostCloneCompose(ctx echo.Context, id string) error
	// Get logs for a compose.
	// (GET /composes/{id}/logs)
	GetComposeLogs(ctx echo.Context, id string) error
	// Get the manifests for a compose.
	// (GET /composes/{id}/manifests)
	GetComposeManifests(ctx echo.Context, id string) error
	// Get the metadata for a compose.
	// (GET /composes/{id}/metadata)
	GetComposeMetadata(ctx echo.Context, id string) error
	// Get the SBOMs for a compose.
	// (GET /composes/{id}/sboms)
	GetComposeSBOMs(ctx echo.Context, id string) error
	// Get a list of all possible errors
	// (GET /errors)
	GetErrorList(ctx echo.Context, params GetErrorListParams) error
	// Get error description
	// (GET /errors/{id})
	GetError(ctx echo.Context, id string) error
	// Get the openapi spec in json format
	// (GET /openapi)
	GetOpenapi(ctx echo.Context) error
}

// ServerInterfaceWrapper converts echo contexts to parameters.
type ServerInterfaceWrapper struct {
	Handler ServerInterface
}

// GetCloneStatus converts echo context to params.
func (w *ServerInterfaceWrapper) GetCloneStatus(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetCloneStatus(ctx, id)
	return err
}

// PostCompose converts echo context to params.
func (w *ServerInterfaceWrapper) PostCompose(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PostCompose(ctx)
	return err
}

// GetComposeStatus converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeStatus(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeStatus(ctx, id)
	return err
}

// PostCloneCompose converts echo context to params.
func (w *ServerInterfaceWrapper) PostCloneCompose(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PostCloneCompose(ctx, id)
	return err
}

// GetComposeLogs converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeLogs(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeLogs(ctx, id)
	return err
}

// GetComposeManifests converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeManifests(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeManifests(ctx, id)
	return err
}

// GetComposeMetadata converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeMetadata(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeMetadata(ctx, id)
	return err
}

// GetComposeSBOMs converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeSBOMs(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeSBOMs(ctx, id)
	return err
}

// GetErrorList converts echo context to params.
func (w *ServerInterfaceWrapper) GetErrorList(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{""})

	// Parameter object where we will unmarshal all parameters from the context
	var params GetErrorListParams
	// ------------- Optional query parameter "page" -------------

	err = runtime.BindQueryParameter("form", true, false, "page", ctx.QueryParams(), &params.Page)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter page: %s", err))
	}

	// ------------- Optional query parameter "size" -------------

	err = runtime.BindQueryParameter("form", true, false, "size", ctx.QueryParams(), &params.Size)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter size: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetErrorList(ctx, params)
	return err
}

// GetError converts echo context to params.
func (w *ServerInterfaceWrapper) GetError(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetError(ctx, id)
	return err
}

// GetOpenapi converts echo context to params.
func (w *ServerInterfaceWrapper) GetOpenapi(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetOpenapi(ctx)
	return err
}

// This is a simple interface which specifies echo.Route addition functions which
// are present on both echo.Echo and echo.Group, since we want to allow using
// either of them for path registration
type EchoRouter interface {
	CONNECT(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	DELETE(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	GET(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	HEAD(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	OPTIONS(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	PATCH(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	POST(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	PUT(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	TRACE(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
}

// RegisterHandlers adds each server route to the EchoRouter.
func RegisterHandlers(router EchoRouter, si ServerInterface) {
	RegisterHandlersWithBaseURL(router, si, "")
}

// Registers handlers, and prepends BaseURL to the paths, so that the paths
// can be served under a prefix.
func RegisterHandlersWithBaseURL(router EchoRouter, si ServerInterface, baseURL string) {

	wrapper := ServerInterfaceWrapper{
		Handler: si,
	}

	router.GET(baseURL+"/clones/:id", wrapper.GetCloneStatus)
	router.POST(baseURL+"/compose", wrapper.PostCompose)
	router.GET(baseURL+"/composes/:id", wrapper.GetComposeStatus)
	router.POST(baseURL+"/composes/:id/clone", wrapper.PostCloneCompose)
	router.GET(baseURL+"/composes/:id/logs", wrapper.GetComposeLogs)
	router.GET(baseURL+"/composes/:id/manifests", wrapper.GetComposeManifests)
	router.GET(baseURL+"/composes/:id/metadata", wrapper.GetComposeMetadata)
	router.GET(baseURL+"/composes/:id/sboms", wrapper.GetComposeSBOMs)
	router.GET(baseURL+"/errors", wrapper.GetErrorList)
	router.GET(baseURL+"/errors/:id", wrapper.GetError)
	router.GET(baseURL+"/openapi", wrapper.GetOpenapi)

}

// Base64 encoded, gzipped, json marshaled Swagger object
var swaggerSpec = []string{

	"H4sIAAAAAAAC/+x9CXPjOK7wX2H5TVXPfO37SJxUTe1znMu5E+foZN2VpSVaYiyRCknZceb1f/+Kh2TJ",
	"lq/uzO7Obr+qt9OxeIAgAAIgAP6Rs6gfUIKI4LndP3IBZNBHAjHzl4Pkf23ELYYDgSnJ7eauoIMAJjZ6",
	"y+Vz6A36gYdSzUfQC1FuN1fJffuWz2HZ5zVEbJLL5wj05RfVMp/jlot8KLuISSB/54Jh4qhuHL9nzH0R",
	"+n3EAB0ALJDPASYAQcsFZsAkNNEAMTTl8kJ4VNtl8HyLPqqhWw/dg3a17VGC2hJ9XE0EbRtLMKF3xWiA",
	"mMASkAH0OMrngsRPf+QYctR65ibK57gLGXoeY+E+Q8uiodkYs7Lc7t9zlWqt3tjabu6UK9Xc13xOYSJz",
	"LPMDZAxO1NoZeg0xQ7YcxsDwNW5G+y/IErKfXt9d4FFoXyrU8+9eYAx4DoWFMeKiUMnl/5nLzuc4gQF3",
	"qXjWu52EyZ8Uoq/zUGUjLBvWVWjsCihCzSUpREEfpyGCPi6UrWatvL1T295uNHYadr2fhbENUTyzGDlv",
	"fgUNdGs/QgJB2PewpVl4AENPxO3SLN0ZAI4EEBSoz+BX4SJgugDFvL/lAQQeJU4e0P4g5BYUyAZ3N2c9",
	"gjlgSISMILsIOoID9BZgBuXQwMeOK0AfAU4pQQwIFxIwoAxQ4SIGQrW2HhGQOUjwYo/0yBQWwUIkp+Uu",
	"ZQIxORtITAYgsXsEpyfEHEjYOfQRgFxNJf9OTgems023qE+phyD58U1dbzsXkWLIvGxRnJxCNsoc/z1k",
	"6EfIxZ0EiD2Pnh1EkMZninRy93L5acppu5RypHB8fw46vjyXjuUw92A6Sh7YeDBADBEBBgiKkCEOKAEK",
	"YADl/48g9mDfQz1iowARGxNHtpDjzg2nNw6R0JfYUEDdVxMYmfInlvDEImfmGJMkQgdqCk0YyAaqg6Ri",
	"4IdcEW5I8Gsoz1rV0MEjRABDnIbMQsBhNAyKimblJJL6qI+FZI0Bo77qIncOcSEJmUFiUx9QgkAfcmTL",
	"FUJwd9fZB5j3iFkhss0CkxJSAZYlgjxqJXYqucAz8yVaZMDoCMtFRuA/K/DzYOwiprdQzSL5LfRstfgI",
	"L5DIbg7mAjEF3zEdSxb1MBcAeh6IwOC7PeIKEfDdUsmmFi/62GKU04EoWtQvIVIIecnycAnKvS8Z2f23",
	"EUbj39VPBcvDBQ8KxMX/wPdIuD/LiZ7jST4plEuIo58k6gkVgAfIwgOM7DzAQv5oIzu0UhuyAA+zSJf8",
	"jkLJH9mSP9l3OXWlyWUNdM+CcktDC5IbM8yRmjHr/A77MQjP2J4HqrMvQUo2+w5g6qhhN/tVqwD71Xqh",
	"Xq/UCjtlq1HYqlRr5S3ULO+gahZ0AhFIxBK4JBC60XpQGRIcYGKrvdYcqmXKFWUCeuvQYkSHAo9QwcYM",
	"WYKySWkQEhv6iAjo8bmvBZeOC4IW5NQFDfIMkhrWNho0+luFilUbFOo2LBfgVrVaKPfLW+VqbcfetrdX",
	"HiVTjM3v7RwFrjgQFh04aQm5jsiZATIxQBYIe16IAoaJ2PAosigREBNjBM2cOdE3TR1cUgHy+1J8E6k2",
	"uEgSBfQAZGIALalVxorqLwwNcru5/ylNba6SsSpK8bhZCqwVckF9/A7jg3XZUPGy2+lu32bOzwzN2cZc",
	"MDq/6lupkslvuB8q1hUUhBzFKo6lraAi6AyAhwYCID8QE/XJpVz0iB4YjLHnKU7i87w9QDZlsFDbyWJg",
	"RWc8yxa1hpJJ9XcJVl+el1xAz0P2usg3o2jhloF/n9qhsSrT07cIgB42ul6gR+F5qSXKvbTVz31oDceQ",
	"2VxhCQrYxx4WE7X6TaDLAizinTl8RbAsxNiP4ioLmhFiPFMbaAGO/BFiwLQARJnxqe3fLm4Xt8srWX41",
	"s7fnmGUD1o/ELM5C3f70o8SexRAUsXYWcz3ehO2jISdZ+BzYdFX/w/1L1RJnkueh/PmjQI0RLEfNBFfO",
	"NuEC+Rn6oNTV6ABM2wBf6lYBxUQkQPwuYMykmSBlCY0DIrV9cNi56gKf2ijTEhtghsbQ8zaAxHSIxNVi",
	"LEyl1WarXiigpJDNtjTalAywo4yeSBqrhlkGi0NwdDIsg6ITtVPONCU+FK8922iErRXWTrID0B3ywAqZ",
	"tM+8CaDEm8jTYRB68eGCbAcVOPYDTynXhUhkMSCXMHOKlGw0KnEbZi4w6rhyhXHDb/ncEDGCVpLBqW5l",
	"jCIPrWp/plt9y+dogAi3YLA2oV0GiHTbrSst55lQm4GJ86xoOWU0w1DQgjfy50znLvKQJYAr1Vh9tg+N",
	"uhsd0fHIyC6CT9FAn/R3efYzOAYh8RDnPSKUziyNaWlfUgZ8ylCKw7FU97HlAgtyJFXmeJyz+/Mi+KTG",
	"ht4YTniPhBxx+XseIGnyjl2kBJeZglCA3gSDyfGL4BOD409A9ZSQxeDzHskaZAGcafOewXEun9P4i1H5",
	"NdMiCyjHi86Nm8RXyfRjhgWS/yghYZUmoV9U/Yt2KS2hjUPgggokUQyF/MYjJAilRQEoQD/Eng0E9lFx",
	"fa0iJqcYuswziLncXzXUzXH3PHXqqo7B6n5X8904YlImrAS/G7WTfbg7RJPF4pZzFwzRhK+Lmm73+BRl",
	"YkPi+J2Sldx9G7X7ls+FXAucbNjk1x85/+54lsnwbZmCpM7vDB1NWxnqiF6lM2g6m1GdoIDZ9pKEPJL/",
	"anTIQeBBOTJ6EwvV/fnB1Pk3OxIEDrYlL0Pj4zDn2/RMYFR59ylBl4Pc7t/n1eX4F0wEciRCv2qtP+v2",
	"CzEfc6nFcqAHiA8qBREmgFoCquPLhyIFSHmrXs9abgCFm6WpCxfENqWXXpMSHf7E/D43YjbRXY6JvjxL",
	"4y+M8Cd7fRD6ZtR2tcKvq6hyqj2mScvHJPs6UP6aXI9RLTEB/YlAPLmMaqW+XW/WturNfO6t4NCCASXE",
	"RGzVtZUXHQNpd0RpBNlKuyTROR/Du2LBUwVzqYUyq9PrbjawjGqnZefc9Qtlgi+WO+oz+FWarZQJwCBx",
	"EP9N+VoDRgW1qKfEktROkmj8e65a3RVWkMvnmmXzD+zDQP1zs1u5NSV9tOCkxJeyVbuQ1hGW0QhPqtdm",
	"wjJWtuaIUso7LhiCfuZyXzglzwJij6pfVoAYTXPSvby4jTtJ0UA9bE0yPZdXoZDcG3udgW4LOvuR0JYH",
	"M5DymucBl4IECgDJRCvhxJKqUuxXB4L2iKRbxxU81gKl1uNDgS3oeRNJcQQph7YRS3IlHpZDRZObmS1K",
	"OPWMPmIk4W4uDJX3cF7+MSq516xynnI2xWICg7NyaDrTUuZMKEVzG9+HHIXMS9PfVFxEXl/LJkWGbBdq",
	"j6+lD8KSjbkoMRd5zVKz9Nbcet6ql+SIlJcoL6WwxXCmL3uGj5CyZpOYS1mxHlroJHICx3KRNczu6gSO",
	"UpqSq1wJzIId9JGAHibDbEz5mDHKeFF7AANG5XYUKXNKUb+/SQX598hDWO2F5XJ1CzLL/V1jcA206Uk8",
	"zMU8EDEM8nPRQkRQrub/G0Meghz93ixoVk/MDOX/btX1Lwq+PcjRZXcdWJQ/8dmlYoDfsj1NXG4qB6ol",
	"ZFhM5PkmUELfULfREZUuuk9e7CBkmMphEx/j01vbM8/LyYNzb4QYHkyyPs/66Vdw253RVjZx1K3wZDtZ",
	"ElPrj9iO3NdSDiJoRxpEZDfnMzCyyAHd0teQdACmwCf8O9C29SWv1KwETar3UxJUzSvr8LpLs3w8t2aC",
	"TxzIBiC+K8oaMtNSkhaSjteQhlJK++PcLSC72mhUdkCr1Wq1axfvsF3xnvY7lYvbg4b8rXPBjk4P2Pkj",
	"/nx+fjcOj+FN68S/OaOd95tB9XW/au833st7t2+lrbcsmOavgORyKtmqMudjyrIu8sxNs2kAuIBMnWTC",
	"Bb9s/ZIHvzR+yUs995dq/5fYA9FHgAsqzz/IewQSgIjFJoE846KRiuBSuIiNccJx0UdAKPvI1ir01Jzp",
	"kbhfkieTkU5IK32zN+YOJkB9NOSZqddnkbVkn++h6nVd68lAtz1qK/qZWgPLDuSMQDllWiV/uUE8oMSE",
	"0HneGqNeKshukIrqsJCyQGZuFu00OVWqNVRvbG0XUHOnX6hU7VoB1htbhXp1a6vRqNfL5XJ5taKyjlSL",
	"Vze99Pz+RS1rn7pa1dNqfHbs/yBM6iWdUYd/6KLUvbFym2XqNwaEtKEo2YYNoIX++JYlmof0Ba90EtMX",
	"rNaSfZFtAFqKinNI8ABx8aH48JOD/jgyZk3jePTlK0MCRj6kj1oYlVoberao72ORGfvxqwu5+1skK+UO",
	"CGCa57/jWlVrA5hYXqjCyC4O7m9aG16txojIcsfqgK7V0QRGtOrWGSZuAvE30zGXKmCECh3aO93amcCE",
	"fK4fh1x8/TarsvWT4RhrOTc3j33ICHlIhC2kRZk0wgrN3MLQvTVxreIOY0zPdF7fSTE7zPfKlzn2SyEg",
	"se3dvcvzj5Wq0TLntVM5F7CpFfrKFywNGBW2r6+cNNfFngMdSpJkmrUGnIZImnuTg+kMIQ+VA8NVSp4A",
	"0qgTQIypGojn1XVQNIi+TkFkhBklcnzlFUu06BFoiRB6wNj08d2mmnddblcbLqfPvGhYJlD18EuF6Udo",
	"H1lnJo/HXb00o5rkU13RhhwxHSWLIdaER/LFdKD1+qQQea9ySGb3wQyUXuA6+3LAGGUZHkUkIFZ+pVlP",
	"Sso0hzzT5p3XqeLGcwDo9UhpaG46eWhZiMu1DCD2QiaNDxMKLReUMAfjhnNScxrCNreyJVHQc5FkUXxd",
	"HDO7MPxYxyBm3bcaMp66KaNBo2i99AWHcoKySdH8pPx1atZdAZ1Mu9zjz1Pvx/yNF6MeuD3rAtUGD7AV",
	"+ejjSVV+wSq/iVlgpk0WLelHYu6XbEu8H8bKtdJxjzNRF5QroZmJKuhkiHDobDiDjsrOtCRW4SYhCzcJ",
	"BHPM2T/rmZO/RxI/Um3nYvmnizGJBBGNZfsETOrFzE3P9f5FdpLADG5eQzgpYlryJyZivWT2Y3cJ1maT",
	"OvLRkjOpTalVazjF/0184spv+ewETrbvUn+OnJzZbX7IrW6cbD/95n+63/zDXN6ce88/6tD+odDTdNT5",
	"RwWNPy8PTTpQgVTJNqlQ5sTlIiYgbYoVwa2LOOqRVO9khLc8bW0UcOqNkMniEQyjEYrHL4JWjCBvkleB",
	"ZHz6eeqihSOTCIT9gLLEDeQ/5mKo/jH1f/eIkb5TqbkeXmfFXQZ6ZyKF/yXRvmvefq8Trrv2UKuDbZeO",
	"0LnqbhJdG13dz8WJLbqP+bcKsU2mtPyMvP3LRt6mA26nHsBEUExAuXAY4puFwPyM3v23iN4N4ERq1/+S",
	"o1Kx3drnZY9ErHnZBVhw5A1UvvxED0aoShuOE5pnXFqMUgEo6xFIJiYrXSI66fxW0V/SwP9NwRxN/MyR",
	"4GCAkWdHY84tB3OAHUJZlNm1lrj9Dwg+TiRHruyXbPsD4cTrH/7rhwfvXxxeeaGDiT7O5i28JQZR5nix",
	"rrM41DhW1L4n3hgRHjL0HEAWFa9ZXmfiQLUHURw90B1BQo8D6A0nreVkMNQaAcnT1eio5DgY2QQnY/tf",
	"EpU8BWtpaPJ2o/F9ocnJaJO5+GQbs+8MT57BZhyabCKVPwKZ68Yox+7aj/KlW2YP5/Nvkx5g2QMm8ukz",
	"sk7WcwVbOsfNNJ8ZONtdrZZ8Zoz+9ZatWi+5FVpLXmlU/8gFiLSRNoyo7uxfGoUYUNKnkK2Krbbxsz9w",
	"njW6nyUQzz60nqWoWrCvOCTPQdh/HqLJswu5u7oVJhxZIVtjPEn7zxYy4d7zThNIQilDQwWsPOIQe15Y",
	"62WO+JXFthlCuzoKP86vBBwJVTVi4YGySnLrYEhVXGdm7Fx+rdPoL5Dz8ieeZytuHX7m2/z35NusSLN5",
	"/qvl2TwvTLTJdh39TLbZMNnm2xLUdhOjfhdWI7DUvazOyqcM2Dr6PePY5YkTIzPTMzHedJQEPgXyCBKb",
	"4S51Tq2aVTdOTzoQcuOICDas1rgQ709R+tMGSN/DxAYwjlYnSIwpGwJ9xaxj1YG0MeW/GJJQWQIIBgcD",
	"bKm7+B4RLuUo7hFXEVPHMhICEyc+8uRIWQdmtgeVJNyUsmce4Lk6MtG0ytEBg8CbqIylZLHA6aQLQgWW",
	"sGg0fHS2KHN7YQhSLyyXa5buo/6N/l7Sv/mQD/UvX/9P/3Leausf/g8HHIld/av6t/599YVmFi0cta9+",
	"5Oq/H1pDJBZ7jCHR2oM8b7u3rYv91s0+6ArKoIOA5UHOwZ4aojhbLc78UTAzbFgZ79ZF2sybiQuJ732k",
	"0FQFOG3Qpn4QCgQOiINJFH7VI7dx6S410EwxvTEWrtHvjtpXwNya5o1/E3PliUv72XQIma7fOL2DUsWO",
	"UmXf4ip7PfLJhLGxAgxwQW95GGJb7/inSJMx00m1QKSg3qQK37Rm5Dwq5RL190Rds3hNkbc4eamWwK/k",
	"eoNPVYczRiWUf2NbjR4VwSuCLkIgvuj3aGgXHUodE07DNemoWmiluJaeKV+Yrp2nAitCT+CCgTyus2d5",
	"lCMuIiXN8B/51ZS4i8hTE2bc7TeJZkvKLpLOZ5xFMgo3qEybLUYMXtS6QdRcwqtGSVNyFvkq8iz2iIpd",
	"NESisG5uhxP5nrFiaaZRdzJFcK8g0MowB5Ch3R4BoAA+SWVz9w/kQ+xh+9unXdAiQP0FoG0zxLk2JRgK",
	"GOLKfInnsuQQYGZZRXBIGTDYy4NP0MMW+t9ECNWnopnZnI8t3W9DGPTUZohFc/uTgvJnF2AQ/C8MAh5Q",
	"UXRMp6hPEiRluWyKDbP+qGKjhGsGBbaPCc/EgU19iMnuH/q/ckLFnqAbYoGA/hX8GjDsQzb5bX5yz9MT",
	"Rslk5qSFwvSdxciU9T5JlerTDEzZXLecNKMql1o4qLwqSCY9EuG3N6O7KoKbo4pcrIxG9LDu5uWMnbo7",
	"j+ZcPmcQnPzxT6mNHZ+7H1fVUJ3Ncvzn2WwbyC1EbEhEoc8gtgu1cq1Rqa00khLD5VcVSTyKTP8NlIfl",
	"yZVGLGnnwNSp8isN9PC/ZSZYri6UOzPg95eK6ySu2zfQoKNuK2xBFV9qa3thncv8g6i9Dovgok+pWLfz",
	"YdwhU0mcm2PjkCRzFbTKwazaLcP1YXJlG4CQGRl5xegIc31vDu5uztYKcMyELpl0sRlgkFkuFsgSxkc7",
	"Zdo4tG6B4qt/XiP2/XYS6DtGnca0MkyheytbZZSj+oCr2KlfyPgky3NeX+MjUovMx76hInhwEYnKqpeT",
	"hXVlBywPVh8T7Id+j9hooOpm9ieJdkqvSR8u9epOfWdru7qztcjJpNX1ZxqslTaUtqSm3U219mzdWs6p",
	"U0N0P2WrKMU18NBsvXeTjSKQD/QieY9AwFEAmRSOprWNpMWllV11wGLBAR2TaIoiODfj98i0rLmZQ1oR",
	"YyStYz4FI/pmZKiqTT9UrgCGeoSHgT7xN7iy17i6VeOuPEhTXJJigBkq/Rpxo8qImTtUAxwgD5OVVqNZ",
	"pol/BlE3Y925xs6KYzb0KH1p8BmbUCUWxUVRi5mHdQRLELLo7Y95cMzHuAC66aTDKv6hwGOUin8kYITG",
	"GhxQph0b85lIdoikzJsyh2piBlW/TAdU8RmRAqkNhcVZS2A/jNMliKqSD+igRzj1k2zI8yYIx4cqaiUm",
	"s2jOFKH1iEFCMRGVE688IofMkBzep/4amV/RTc0n2V7R1Sdj+iR2bp0E1rj/ElY3K0sBUATtdARd92r/",
	"ixRqU85KrJ0H9lvGcmezPvpaS45Bys+QfwYJTtlngVaKojvstXOe4qvYjXO+TLZULEXXGyCd0D7TeYNz",
	"bHacpfIpytlKo2+j9Ki8Jmn9Tw20/ndUW8nkUM3ReOKMT0wFx3IaOOYFFxaYG2LzV+KfHAbxn+8aGP18",
	"AYLBdupL+o9EPxXZGec5m7+iYHLzwzRoM59z1N2DY8UDOFJlig0a9d9UB0xFQap7sO+lh5Yf4on1H+mP",
	"s6MwOJ7OQ0VmPGoun/PwKA2BUiqgV9BhgNSSUI94IMXX9F8FOoK5fG7MvQVbJJn41JRBSnPUfBT2d3hx",
	"O8nA2PT4PLRpgVBVTcTeLJskJFAIROz1o7VO41DbTVTgQPJAxrW6+p0DyByTn2sOFkkQKo+JAR3bq1Lt",
	"pQolhVnKF0co98XvA8ostKxizGJr0UwQl1KZDq2/FGzUD531EspOTe71d6TWTac91Fk4bY+GdmEP8gW+",
	"XJU3k+5ZLVfL5Z3ydrGc6Z9UER3ZGUJD+oIz0oPkz27YXyexCvLhrFeiXs2y3xPF36dw1Fa/WWTAn05l",
	"Nnc64hQrXxfsTVQfZNYRI5nXZNMSVf9hLpCIaDGkWy4aftGZquT+OtjJoqkouCo9pFTNFxT0d9CCxCVj",
	"mc1/EVRAL+vTDBbUpPn4UT79Fp7unF8Ya5VXb/x4P3IHpeL1nzkcodXRLrcu5vF1CSZScPRTlpK+2Ni7",
	"65ztP59dtltn3db9QVJ3hl6PjCDD+pY5uraUxJe4feZwFOnX5gZHXSN43kTq2JirF8eknWejEfJooJTQ",
	"UKr5xJvk9e2QdpNOg7C1CGIL3vya2YsEThbiHG3ouNKdVrithmiiQt/mpWoXGfshagI8OKFhOtQmzEwJ",
	"9yBxwuyCKdGNiU7amHuOIm9iTZhsRRDoI4v6iAPjIc+rl4TQa6gMGWl3QCa306LEhibLNuGKRuT5rlu8",
	"uz0sNH/0Dv6y3dmM5heP8Kc8xGa8QLt/ZKQXIiIy/Wkt9bydspHV1TtHIh8zm6T2ARKWKxnDjFIEHamE",
	"IXNL8o+Qef9QVg8SkRci3yPa6E5lBCoXialvo3hmwX29DmbLCK2DRI6FsMpegKZUD/jV7PUuKFe3yvV+",
	"1YZbaKdR79u1er/Zb1Zhs9ZADbi9bVf7W+XBAP6W1yFYfQaJ5RY8PESAxXUDpuMxF3nTpGSpF/82c2s4",
	"3yL7YB/MV59Zo5vJgFguHPeRQMxX5vfYRQY1+ioy9eCWDwl0EAO/WpDYHgow+Q1gGxGBxUS/bqjpS0VW",
	"QGXyzBWaBG1KeOgjBixJXKq2wWzeJ+TA8rBkzXQbF5EeiWkppgMpNSPCWlDHcv141dno6zlGcM1WzHtn",
	"s0/eBUdyVrkNc5CqGTJ5c2Ex4Z/Vgv+C1YKztyHTUIwiTjdbzGJw8tNRl0G2BCqucgjRxpbl9/TL4tPo",
	"HakPq1gSOVpNITZBI2WiCA6xh4Dj0X7fBN3E3rl8jyCnCD6pVFDuFv7fpxnpLvwws2TpwreuLs0tZ/zW",
	"1RK4otfS+h4kQ11ZSlfsSGiP0TCpp9PAA/ZsSz0qpvSeaDlmNfVipVKcW0qtWIPff2maeiPtIzYt9XTb",
	"fBQ0JFApcwVBqcd/GO5kdcH5i7xMGkYBXfBlYYmJhPk+b6djx7cbiz5pn/sSXvpjKQ2ueMxRe5EX2tV5",
	"jYQYxq8Sb6EXaF3yh8IMIUfZ0fZ75ou2puIadcb4miocuWXP7UyWPLajkgq1ZW/uhARDKNIYVS3mBb6U",
	"ZxMCpIT3UgfJDJ7j1WYS4gxCF2n/qizNWiZA3DJrOpUXuyCV0yaD50Ale/I1UlbPIYmTQ7kZcvbFV6NZ",
	"rjdaNMa3RWDPRuwvikpYmRe8bKKrVfNo2nmOiuAvv/yI/cTZk61HsCkLvdgjrahSocp31+fIJ1Np6VMe",
	"fJoW31F/maI/n8B0HSp4sEf6aKr4qWNHZc7rEX19hKQjwSizdYBhwJCFbGUUYV0qIH7fXM4rlf0+HWXG",
	"eidKQv3zKkFtXPlpvdQzJ3BMMbf0u9ZTSRSbMwssmGlVqJmwqasjMESTuACAPAumF9RKQU4bYKlTsiD/",
	"b+/gqHMBro6uwNXd3lmnDU4PHsHe2WX7VH3ukR7xrzsXe0ctq2vRvYPW/tmg+Xg8RO8nW9D2zh/H2/Do",
	"qOOdQE80T16qb6W96ulntzPohG9HIrh/2UY9cnbj7N9tb73A20Zwv9/wD89PasEQEXRTsm7919fr4cXk",
	"mrtfqvT6y/jg/a7br7QvztuD9pEz/NK8rvbI+9OQdaw2OyxfV8fstO/B0HbvPuN7SFr73K80Hw9eeb/R",
	"uqtt2+KOndeuH+0HZ+fm8xd8Nbhv3vTI6d7Lbbk2ut+7tM+7/LG2cwbbZKsTVC5HQbNzQEsddHD/WHn1",
	"25dXLXha7p8c18KBU2+HaMg/33Z7ZHz9cIvaZ2/h09nW5fkXenl1Oh6dXw/e+k7ly35zFD6VT8VLybo4",
	"rr7BsPzm81a4c3wSoOHo8urmzeuRyat4mTwNGL3H6HASjJ+c0fVYEHLeLDndg7B0cn/LHsuNqn9wd7vd",
	"tvrb9aF1fHh7ODgfemR4VOqR8uCu3rqBjXL9uPb2Uh6KPqqNTq2rL/TqMjzdu+fH3VG5fHf02JpcoXDy",
	"ublt3ZUeD9zz7WGte3/60iNbqPPkTPD5ZXnsVR6P9m9OrdAbD/lO63PoDZ0Kve3Xee3dfxpdlbeP6O3b",
	"Q736Ak8bD93PF+4TQj3S3Cp/ofdu36qcBt3PL4Mn+sLZgXhqXvXvnj4/jg6bNwGzH1rs5bh/MqyeBDen",
	"rbdb941ft/iee1TpkfJZ+FZ9gOd7ZafaaVxZ5/ZJyXp9oeWmZbGXvS8hfntguIHDnfMvQfP1tjTovl/4",
	"3O44pFl6fTrtEdy8Dr1BuL0dvroPpbGo9gXBwrnhry/u23n48nhXf+rX3aE4bLqnd6UvX7br1Vf3rHE6",
	"bt20rlt7PSL2D4+eHm5Gln/gnO6fV067reaTfz/s107cs9vzytmXvQl8qLgW8VrR79bxyQj69y92uzHq",
	"Ecu3PuPrk8u9vfO9dqtVP8QHB+h4y2fu4fF2eM+vz87Pq+XHhvXkkrfH5mHLVzzUPho3D9vjYadH9sad",
	"o8NretJu8fbe3mO7NT5oHzsH7cN6q9V2htfT3p8vHlul7b3HwPEm3dbT47H7Mjl1e6T0ebD1fjW4H/WP",
	"q+WD19qws315uHdRJmdfPu/dVfxw1P38eht2aw9nbK/m145CTwSnNwcnp2fCbxzs90iFHb1/adHbyiTY",
	"eew0z1r79nm7fTl5ab1w+nDX3H68C9ufS33ywm7RTfXs5rI9mFy1t7cedpoNfHnfI36j+7nPr/fH2+3q",
	"GfPs1nn9fD+kk6dKF4sj+FQ/vT67F59vD2Cljvlj96j98k63rx6b97WTy2Gj3CPO64PTrF6U+n714L27",
	"fdusPRzs9yve6KXe8UZvTuf1FDmVyvuXxzefPXafTk7ag9H74LN30d0K35zjHnl5K52UJ95T9Qz3j9jW",
	"Uas1udy5e2Ctp+64e14+sF5um+ODNnkbdvfDyav/ML4fXex9CQ86981LVHvskXN8VxmcXDS5vb0f8MO3",
	"xvnnLzY5J9fdz8fs5fbqdL/mPzCvZZODW9d+vG++PA2DB3d/wmulnR102SPusMzOyKT8cjEewnBQwnfN",
	"S2vry+h8+HJ2c37iNO527k8nJ+HDg3gffyEv5xeNh5vDvdfTOn+i/vl5jwxE//a48rkx6d88lFq10V4f",
	"vt08VMX23fvFi/WOht2nAwzPLnbOSsfWSbtzU7k+bG41q/t2yzs43LF7ZFh1rvFj97oF4Un55KT1fjy6",
	"Gd6cnJ05p9XH60d8fHE/qYrayeRwwBn0G+Nu++Fy4F6hzuRs7/bppEdGLLjwrvpowG93Gtu3g+reRSd0",
	"3p9Yu3H/tt89HT45N27l/mjU7VyT9uR9eD3ZOrirvl4F+KGxI2WUe9X58sROqXVaOz3r7pTw+8n17Y0n",
	"Xs5bv/fI71eD2+0eUafLwcX+sqNnQbkrytAz5172If2z6uHq14KWuoM/6vWgZPWfTK+LHC9ybOgSQcqp",
	"ntCKIJcKDQfK5EpklKjKQz3yaxTJ9FtmFaK5nIKozCzdsNLWx/rR065ysMBTvmZpAvPa6GZ2daYq2bLt",
	"+KIu8rmad4FgKFzK8DuylT0zn9++1jM/re4DFsPL4/pdc7t+YPO9OzIR/Vp/PLpxnGPv2us/fvG2SaU8",
	"2llQ5zYzTf5OP44Umz86T8q82ipJKu0Ysn1MVkd8cxVUIPGUZR2vnbn8ARnIoD9JPMKTUR03KoZoZ0si",
	"0tFdKh+SmrwSGjJQQVt8Y2B8yIfrwiLbroREJ2tvipVMHkv6HeY9LmuUGdMjJJ0KWqhYiAl7g86y+TK3",
	"xAJ/y3xANKN2GGcMLS06OlPY6ztdN3PDLIZ+dqHzLtdQ0GdTERvOPOG2XFbO7sJuxlM2+vmNgPINRk2V",
	"cJsB1hJ4pMslGambyuniyGJIFPSzafFRHj9TlkG7fcjRc6ZjZN4vsoZ6EN3CpYZbVOiFMgeShMcrGWRW",
	"L9eq9exLaGv12Rnfeww86ETZ28y1dD0BfW+YqOATJVxDj1NTOdIIKA46ZkUzp/+iNaVLGiWfKphua1Hy",
	"agKxK/E6c5yk8JafpYkUDIkNTmxO1iF0myj/t0E4T9RtRUAPEYGGaknwDREBiBql9KxykVAm3AL0EcMW",
	"LAaUekUiAqnn5vK5yrLPGylmyRKIiy/1olb56MBQh8jdbTulGdx1SwdQ0hlZL6xz/mKDTNZ+1G42ZWhl",
	"n25tsy5zBR5WzvEeMrRZlwWvSKzqlhH5t6rLXNjUqg6L7p++fc2WPJHtoZ8Ams+nUoUMMAfcpaFnA4ZU",
	"jEJf1ZK9HIB+KMD8Jun0NBVqJlQ+TMbe68BA4CNITDgU9DyQ0RBoyuM9AhnSgk/bFnPzwritkZIjTNXF",
	"sPbNS4B7hIUe0pVlGRpQhvJgjIALR3HpDEXNQKXryNX1EYBjGFUMwwJgTj6JHgko59jEKfr4TUXj+FBY",
	"rr4kMPsBBHWURSSFcsw7i+6wEml3mzwUOZO6sTZLrdljNnV7A4Zas0f2yyNr88aa7RfcJKoiapvn2sTZ",
	"OuvkpZrkP52Yuug5JHPdHBHB1xly2TC7hoWELEqhSeUizlHhxgv6wbTR7Fv3mSG/LjyIFqcCFXktzsGJ",
	"Mn6SaTPUwkUjMHQJFInA0AuKJnHYlEbPRuHmby9Pa+//0GPGc9r0z6eGf+yp4TWsj/WiZpRSbYUMi0lX",
	"krre9j0EmaaVvvrXYTTdycOtVIFVS6ma63bxqNKyyX37pkyVAc2KL9e1XQQ1zj8VRa9jpHTuKS+qBC8L",
	"mWeC9SbmWgG0XASqKi9Gqf+xk3g8Hheh+qw8s6YvL5112gcX3YNCtVguusL3tAoqFCFcdvfU9CYLkgFV",
	"xAjAACeCZnZz1ejpAPlhN1crlouVnK4pqdBUsjxKEC/9ge1viluyymwdIR2UomWmKrgFjKCTdKMiJZGI",
	"3nvSb6HB+G1Eo8roZ0YTzkrKVOrBNDtYVcrAlAAlYpGt01Hj+r8dW4OSfLBYxV5DHwllOPw948nUKMc/",
	"Al5Q4KhCX5go2hNuFGu0G71CF1GcNuG0+PxT3hX+KmfT70mrzaiWy4ngd5O05plL/NKLKZ88BWjp4Z7A",
	"kiLnNGaSOJEkUv/AqU0u7vykHaJVyChZBdt66sqfP3UrVOVSh0j5w7EGRM9e+/NnvyNTl7akwAAxSRsg",
	"pm0NSf2fAcmQ0DGZ2YLGP2P37wh6C3SItcrvBtRSD7rYKRGuuDgS3n//KnmEh74P2cRktyeFkBJeMT2p",
	"cUrRH6rQadajeG1d4QcCgsZR1zwIqFw6jmLBuakmqDzBI8RgJNyVvDcGm3oVVl9dYJY03/i84LqiXESv",
	"yscvI0fv038Mx88+o/xtVph9m5M3lY+evWNnbb35qEpaKPUD2f8yocOmrxb/lDw/Jc+akscIjSxJ81HK",
	"0wb6UoTDFYpS6nXltVSleOD/MmUphakMCkrj5afC9FNs/UUVpoXySxuCSa0pQ3+RTaZKzBryJCGs/o2k",
	"yJ+geyUwowb+Z2tfiflvzCRZJKVKj6HxtEZqX1XoMq9aZ8s1gd5ESflx0vDMonZt6VX/qAmyePNb6tSW",
	"aElVB1/CAJ6py/E9p/gAE8zdxCEOlp7hWEyPbl2HQV2w+EhAgImmYUwJgH0aChO6z0NPLDvmVVmRn4f8",
	"ykNe4WkBa0gSiIu467u52EDEBBCq33q0Qg8yU7oN/CpcGjquuR076V5e/Fb8j2OkI1Wh3ImuLSMqz2Kj",
	"6JX51bwUt1yDnW6QCBnhKrcofsdeAqNscCPOosfrlXw3RSzjxhZVjBWXdzLbFxXxhAIk3bGmJqOO1IUk",
	"eqO+EA1XbCxhxfMYBT/5cSU/TpG1gClT2z3HmP+ZvJZmjzWYLpEwvJzn4nImkuXm+Ey/n4DeoCVSBxFT",
	"7IdsYCNdLY2meC12/avqt8s4I4LzJ2OsZowIV4v4ItrKTfjip5H600j9dzNS52TTannH+9RfrGBEygIE",
	"OhIqXQWXr9AbemSmOWRxG1Uwd1qzd6HLbe/yfMPDX8Kkw6e0mAPRGP8lrje12gWSTn38bzv+p4ueZQXF",
	"Z0nqnyPD6YO4czSYtRfTJiVVVnFRSFeinaq7+KcSxnQNWYI/fhrOIOPnifOvOXG0zP/rnTfTtwWh54E4",
	"qjSipimbrb7cgSQuOha5PDVk0+pl/QlQgjWbUdd3pSLT/IfOhNo/WcIv3Er1ASR/+8nFP7l4Ey5G8xQk",
	"OTeOd1t8Ql6aJj9I97OhiHMLNaAoWSCVSDlE9PjzX1BFX7qcb3F6U5YUOzdvxqlMQPXQYVxMOx0NCQNc",
	"VBXuXDzQeWUwwCVdtF854RArRA9WlkZVpa3MxGgK6GDiLJuAC+igH5zG0o9pmDft4mlWjfP12/8PAAD/",
	"/5T24cTIygAA",
}

// GetSwagger returns the content of the embedded swagger specification file
// or error if failed to decode
func decodeSpec() ([]byte, error) {
	zipped, err := base64.StdEncoding.DecodeString(strings.Join(swaggerSpec, ""))
	if err != nil {
		return nil, fmt.Errorf("error base64 decoding spec: %s", err)
	}
	zr, err := gzip.NewReader(bytes.NewReader(zipped))
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}
	var buf bytes.Buffer
	_, err = buf.ReadFrom(zr)
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}

	return buf.Bytes(), nil
}

var rawSpec = decodeSpecCached()

// a naive cached of a decoded swagger spec
func decodeSpecCached() func() ([]byte, error) {
	data, err := decodeSpec()
	return func() ([]byte, error) {
		return data, err
	}
}

// Constructs a synthetic filesystem for resolving external references when loading openapi specifications.
func PathToRawSpec(pathToFile string) map[string]func() ([]byte, error) {
	var res = make(map[string]func() ([]byte, error))
	if len(pathToFile) > 0 {
		res[pathToFile] = rawSpec
	}

	return res
}

// GetSwagger returns the Swagger specification corresponding to the generated code
// in this file. The external references of Swagger specification are resolved.
// The logic of resolving external references is tightly connected to "import-mapping" feature.
// Externally referenced files must be embedded in the corresponding golang packages.
// Urls can be supported but this task was out of the scope.
func GetSwagger() (swagger *openapi3.T, err error) {
	var resolvePath = PathToRawSpec("")

	loader := openapi3.NewLoader()
	loader.IsExternalRefsAllowed = true
	loader.ReadFromURIFunc = func(loader *openapi3.Loader, url *url.URL) ([]byte, error) {
		var pathToFile = url.String()
		pathToFile = path.Clean(pathToFile)
		getSpec, ok := resolvePath[pathToFile]
		if !ok {
			err1 := fmt.Errorf("path not found: %s", pathToFile)
			return nil, err1
		}
		return getSpec()
	}
	var specData []byte
	specData, err = rawSpec()
	if err != nil {
		return
	}
	swagger, err = loader.LoadFromData(specData)
	if err != nil {
		return
	}
	return
}
